/*
 *	quick program to display the 200Hz system timer ticking
 *
 *	by roger burrows, dec 2011
 */
#include <stdio.h>
#include <osbind.h>
#include <time.h>

#define TEST_LENGTH		30		/* in seconds */
#define ticks()	(*(volatile long *)0x000004ba)

int count[TEST_LENGTH+1];

int main(int argc,char **argv)
{
char *save;
long next, n = 0L;
int secs, i;

	save = Super(NULL);

	printf("\tElapsed time display (from system tick counter)\n\n");
	printf("\t    secs\r\t");

	secs = 0;
	next = ticks();
	do {
		n = 0;
		while(ticks() < next)				/* wait for next second */
			n++;
		next = ticks() + CLOCKS_PER_SEC;
		count[secs] = n;
		printf("%3d\b\b\b",secs++);
	} while(secs <= TEST_LENGTH);
	Super(save);

	printf("\n\n\tSec   Count\n");

	for (i = 1; i <= TEST_LENGTH; i++)
		printf("\t%3d %8ld\n",i,count[i]);

	printf("\n\tPress a key to exit");
	getchar();

	return 0;
}
